# coding: utf-8


"""
IGNORE:
    Nutanix Data Protection APIs

    Business Continuity with full spectrum of Disaster Recovery and Backup solution. Spanning across Single PC, Cross AZ, MultiSite. Configuration of Recovery points, Protection policies, Recovery Plans. Execution and monitoring of back up and recovery orchestrations on OnPrem as well as Cloud.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_dataprotection_py_client.models
from ntnx_dataprotection_py_client.models.OneOfdataprotection.v4.content.ComputeChangedRegionsClusterDiscoverSpecdisk_recovery_point import ComputeChangedRegionsClusterDiscoverSpecdisk_recovery_point  # noqa: F401,E501
from ntnx_dataprotection_py_client.models.OneOfdataprotection.v4.content.ComputeChangedRegionsClusterDiscoverSpecreference_disk_recovery_point import ComputeChangedRegionsClusterDiscoverSpecreference_disk_recovery_point  # noqa: F401,E501

class ComputeChangedRegionsClusterDiscoverSpec(object):

    """Specs required to fetch the cluster information for compute change region operation.

    :param disk_recovery_point: (:attr:`disk_recovery_point`) Disk recovery point for compute changed regions operation.
    :type disk_recovery_point: required
    
    
    :param reference_disk_recovery_point: (:attr:`reference_disk_recovery_point`) Reference disk recovery point for compute changed regions operation.
    :type reference_disk_recovery_point: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'disk_recovery_point': 'OneOfdataprotection.v4.content.ComputeChangedRegionsClusterDiscoverSpecdisk_recovery_point',
        'reference_disk_recovery_point': 'OneOfdataprotection.v4.content.ComputeChangedRegionsClusterDiscoverSpecreference_disk_recovery_point',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'disk_recovery_point': 'diskRecoveryPoint',
        'reference_disk_recovery_point': 'referenceDiskRecoveryPoint',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, disk_recovery_point=None, reference_disk_recovery_point=None, *args, **kwargs):  # noqa: E501
        self.__disk_recovery_point = None
        self.__reference_disk_recovery_point = None
        self.discriminator = None
        self.__disk_recovery_point = disk_recovery_point
        if reference_disk_recovery_point is not None:
            self.__reference_disk_recovery_point = reference_disk_recovery_point
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'dataprotection.v4.content.ComputeChangedRegionsClusterDiscoverSpec'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def disk_recovery_point(self):
        """
        Disk recovery point for compute changed regions operation.

        :type:
                :class:`~ntnx_dataprotection_py_client.models.dataprotection.v4.content.VmDiskRecoveryPointReference` | 
                :class:`~ntnx_dataprotection_py_client.models.dataprotection.v4.content.VolumeGroupDiskRecoveryPointReference`
        """  # noqa: E501
        return self.__disk_recovery_point

    @disk_recovery_point.setter
    def disk_recovery_point(self, disk_recovery_point):
        if disk_recovery_point is None:
            raise ValueError("Invalid value for `disk_recovery_point`, must not be `None`")  # noqa: E501

        self.__disk_recovery_point = disk_recovery_point

    @property
    def reference_disk_recovery_point(self):
        """
        Reference disk recovery point for compute changed regions operation.

        :type:
                :class:`~ntnx_dataprotection_py_client.models.dataprotection.v4.content.VmDiskRecoveryPointReference` | 
                :class:`~ntnx_dataprotection_py_client.models.dataprotection.v4.content.VolumeGroupDiskRecoveryPointReference`
        """  # noqa: E501
        return self.__reference_disk_recovery_point

    @reference_disk_recovery_point.setter
    def reference_disk_recovery_point(self, reference_disk_recovery_point):

        self.__reference_disk_recovery_point = reference_disk_recovery_point

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_dataprotection_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ComputeChangedRegionsClusterDiscoverSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputeChangedRegionsClusterDiscoverSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

